"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importDefault(require("react"));
const is_1 = __importDefault(require("@amaui/utils/is"));
const merge_1 = __importDefault(require("@amaui/utils/merge"));
const hash_1 = __importDefault(require("@amaui/utils/hash"));
const isEnvironment_1 = __importDefault(require("@amaui/utils/isEnvironment"));
const style_1 = require("@amaui/style");
const AmauiThemeContext_1 = __importDefault(require("./AmauiThemeContext"));
const useAmauiTheme_1 = __importDefault(require("./useAmauiTheme"));
const resolveValue = (value) => {
    const toFilterOut = ['id', 'element', 'subscriptions'];
    const valueNew = {};
    Object.keys(value).filter(item => toFilterOut.indexOf(item) === -1).forEach(item => valueNew[item] = value[item]);
    return valueNew;
};
const AmauiThemeProvider = react_1.default.forwardRef((props, ref) => {
    const [init, setInit] = react_1.default.useState(false);
    const { root = false, value: valueLocal = {}, children } = props, other = __rest(props, ["root", "value", "children"]);
    const refs = {
        root: react_1.default.useRef()
    };
    const valueParent = (0, useAmauiTheme_1.default)() || {};
    const [value, setValue] = react_1.default.useState(() => new style_1.AmauiTheme((0, merge_1.default)(resolveValue((0, is_1.default)('function', valueLocal) ? valueLocal(valueParent) : valueLocal), resolveValue(valueParent), { copy: true })));
    react_1.default.useEffect(() => {
        if (refs.root.current) {
            const amauiTheme = new style_1.AmauiTheme(value, refs.root.current);
            amauiTheme.id = value.id;
            amauiTheme.subscriptions = value.subscriptions;
            // Init
            setValue(amauiTheme);
            setInit(true);
        }
    }, []);
    react_1.default.useEffect(() => {
        var _a;
        if (init) {
            value.update((0, merge_1.default)(resolveValue((0, is_1.default)('function', valueLocal) ? valueLocal(valueParent) : valueLocal), resolveValue(valueParent), { copy: true }));
            const amauiTheme = new style_1.AmauiTheme(value, (_a = refs.root) === null || _a === void 0 ? void 0 : _a.current);
            amauiTheme.id = value.id;
            amauiTheme.subscriptions = value.subscriptions;
            // Init
            setValue(amauiTheme);
        }
    }, [(0, hash_1.default)(resolveValue(valueLocal)), (0, hash_1.default)(resolveValue(valueParent))]);
    const update = (updateValue) => {
        var _a;
        if (updateValue !== undefined) {
            // Update
            value.update(updateValue);
            const amauiTheme = new style_1.AmauiTheme(value, ((_a = refs.root) === null || _a === void 0 ? void 0 : _a.current) || ((0, isEnvironment_1.default)('browser') && window.document.body));
            amauiTheme.id = value.id;
            amauiTheme.subscriptions = value.subscriptions;
            // Init
            setValue(amauiTheme);
            return value;
        }
    };
    // Update method
    value.updateWithRerender = update;
    if (root) {
        return ((0, jsx_runtime_1.jsx)(AmauiThemeContext_1.default.Provider, Object.assign({ value: value }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ ref: item => {
                    refs.root.current = item;
                    if (ref === null || ref === void 0 ? void 0 : ref.current)
                        ref.current = item;
                } }, other, { children: children })) })));
    }
    return ((0, jsx_runtime_1.jsx)(AmauiThemeContext_1.default.Provider, Object.assign({ value: value }, { children: children })));
});
exports.default = AmauiThemeProvider;
